<template>
  <b-container>
    <h1 class="mb-4 display-4">Notre catalogue</h1>

    <!-- Fil ariane -->
    <b-breadcrumb :items="itemsAriane"></b-breadcrumb>

    <div class="row">
      <div class="col-md-8 col-lg-10">
        <!-- doc pagination https://jasonwatmore.com/post/2019/08/21/vue-js-simple-pagination-example -->
        <!-- Pagination -->
        <div class="overflow-auto">
          <jw-pagination :items="dataList" @changePage="onChangePage" :pageSize="12" :maxPages="10" :disableDefaultStyles="true" :labels="customLabels"></jw-pagination>
        </div>
      </div>
      <div class="col-md-4 col-lg-2">
        <!-- Ordre -->
        <b-form-select v-model="selectedOrder" :options="listOptions" @change="changeOrder()"></b-form-select>
      </div>
    </div>

    <!-- Fiches résumés -->
    <b-row cols="1" cols-sm="1" cols-md="2" cols-lg="3" cols-xl="3">
      <produit v-for="prod in pageOfItems" :key="prod.id" :moduleContent="prod" :moduleName="moduleName" :pageName="pageName" :listProducts="dataList"></produit>
    </b-row>

    <!-- Pagination -->
    <div class="overflow-auto">
      <jw-pagination :items="dataList" @changePage="onChangePage" :pageSize="12" :maxPages="10" :disableDefaultStyles="true" :labels="customLabels"></jw-pagination>
    </div>
  </b-container>
</template>

<script>
import jsonConfigBuilder from "@/config-data/config-products.json";
import Produit from "@/components/AppCatalogue/produit.vue";

const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_DATAS_ACTIV = URL_API + "api/popups/list/activ/";
const MODULENAME = "produits1";
const URL_CATEGORIES_LIST_FROM = URL_API + "api/categories-from-name/";
const customLabels = {
  first: '<<',
  last: '>>',
  previous: '<',
  next: '>'
};

export default {
  components: {
    Produit
  },

  created: function() {
    this.getCurrentPage();
    this.getCat();
  },

  data() {
    return {
      dataList: [],
      contentRaw: [],
      moduleName: MODULENAME,
      pageName: null,

      catName: null,
      scat1Name: null,
      scat2Name: null,
      scat3Name: null,
      tableCat: [],
      itemsAriane: [],
      jsonConfigBuilder,

      // pagination
      pageOfItems: [],
      currentPage: 1,
      rows: 100,
      customLabels,

      // gestion ordres
      listOptions: ["Ordre croissant", "Ordre Décroissant", "Date croissante", "Date décroissante"],
      selectedOrder: null
    };
  },
  methods: {
    onChangePage(pageOfItems) {
      // update page of items
      this.pageOfItems = pageOfItems;
    },

    fetchDatas(moduleName) {
      let payLoad = {
        categorie: this.tableCat[0],
        scat1: this.tableCat[1],
        scat2: this.tableCat[2],
        scat3: this.tableCat[3]
      };

      this.$axios
        .post(URL_DATAS_ACTIV + moduleName, payLoad)
        .then(response => {
          // console.log(response.data.data);
          this.contentRaw = response.data.data;
          this.structureData();
        })
        .catch(error => {
          console.log("error", error);
        });
    },

    structureData() {
      this.dataList = this.contentRaw
        .filter(mod => {
          let arraySimplePrices = [];
          mod.data = JSON.parse(mod.data);
          mod.dataprix = JSON.parse(mod.dataprix);
          // structuration prix simple pour meilleur lisibilité coté front
          mod.dataprix.simplePrice.forEach((prix, key) => {
            arraySimplePrices["prix" + parseInt(key + 1)] = parseFloat(prix["prix" + parseInt(key + 1)]);
          });
          mod.dataprix.structured = arraySimplePrices;
          return mod;
        })

        // classement par ordre
        .sort(function(a, b) {
          return parseFloat(a.ordre) - parseFloat(b.ordre);
        });
    },

    getCurrentPage() {
      this.pageName = this.$router.currentRoute.name;
    },

    getCat() {
      // console.log("ALLPARAMS", this.$route.params);
      this.tableCat.push(this.$route.params.categorie);
      this.tableCat.push(this.$route.params.scat1);
      this.tableCat.push(this.$route.params.scat2);
      this.tableCat.push(this.$route.params.scat3);
      this.constructAriane();
      this.fetchDatas(MODULENAME);
    },

    constructAriane() {
      let configCat = this.jsonConfigBuilder.filter(mod => {
        return mod.module == this.moduleName;
      });

      let nodeCat = [];
      this.$axios
        .get(URL_CATEGORIES_LIST_FROM + configCat[0].confCatSlug)
        .then(response => {
          // construction de la liste des données du module (news)
          nodeCat = JSON.parse(response.data.data[0].data);
          nodeCat = JSON.parse(nodeCat.categories);

          // let arianePath = "";
          let arianePath = "/" + this.$router.currentRoute.name;

          this.tableCat.forEach((lvl, idx) => {
            arianePath += "/" + this.tableCat[idx];
            if (lvl !== "" && lvl !== undefined) {
              let elm = {
                text: lvl,
                href: arianePath
              };

              for (let i = 0; i < nodeCat.length; i++) {
                if (nodeCat[i].slug == lvl) {
                  elm.text = nodeCat[i].title;
                  if (nodeCat[i].children.length > 0) {
                    nodeCat = nodeCat[i].children;
                  }
                  break;
                }
              }
              this.itemsAriane.push(elm);
            }
          });
        })
        .catch(error => {
          console.log("error = ", error);
        });
    },
    changeOrder() {
      console.log("datalist", this.dataList);
      switch (this.selectedOrder) {
        case "Ordre croissant":
          this.dataList = this.dataList.sort(function(a, b) {
            return parseFloat(a.ordre) - parseFloat(b.ordre);
          });
          break;
        case "Ordre Décroissant":
          this.dataList = this.dataList.sort(function(a, b) {
            return parseFloat(b.ordre) - parseFloat(a.ordre);
          });
          break;
        case "Date croissante":
          this.dataList = this.dataList.sort(function(a, b) {
            return new Date(a.created_at) - new Date(b.created_at);
          });
          break;
        case "Date décroissante":
          this.dataList = this.dataList.sort(function(a, b) {
            return new Date(b.created_at) - new Date(a.created_at);
          });
          break;
      }
      //
    }
  }
};
</script>
